'versie KLOK7.BAS dd 22/1/2004
' Analog Clock

SCREEN 12                       'pix values
x0 = 320: y0 = 250:             'centre clock
bs = 200: bh = 185: bm = 195    'lengths hands
pi = ATN(1) * 4:
eps = pi * .05: epm = pi * .1: eph = pi * .2    'hand arcs
t$ = TIME$
so = VAL(RIGHT$(t$, 2))
t = TIMER
zet% = 0                        'chrono counter

DO
t$ = TIME$                  ' get time
s = VAL(RIGHT$(t$, 2))      ' secs
m = VAL(MID$(t$, 4, 2))     ' min
h = VAL(LEFT$(t$, 2))       ' hrs

IF s = so GOTO loopen       'within same second, do chrono loop

so = s
t = TIMER

LOCATE 1, 60
COLOR 13: PRINT USING "##"; h;
COLOR 11: PRINT USING ":##"; m;
COLOR 14: PRINT USING ":##"; s
COLOR 15

tel = 1 + tel MOD 20                           'new color...
col = col + tel MOD 2                          '...every...
col1 = 9 + col MOD 7                           '... 2 secs

'draw minutes...
FOR i = 1 TO 60
alf = i * pi / 30
IF i MOD 5 = 0 THEN a = 1.1 ELSE a = 1.05
LINE (x0 + bs * COS(alf), y0 + bs * SIN(alf))-(x0 + bs * COS(alf) * a, y0 + bs * SIN(alf) * a), col1
NEXT i

'... and central circle + date string
CIRCLE (x0, y0), 10, 9 + col MOD 7               'central circle
PAINT (x0, y0), 9 + col MOD 7
COLOR 9 + col MOD 7
LOCATE 1, 10: PRINT DATE$
COLOR 9 + col MOD 7 - 8
LOCATE 1, 35: PRINT "BasiClock ";

' determine hand angular positions
alf = -pi * .5 + s * pi / 30
bet = -pi * .5 + m * pi / 30
h12 = h MOD 12                    '12h cycle
gam = -pi * .5 + (h12 + m / 60) * pi / 6

' clear hands
LINE (xss, yss)-(xs, ys), 0
LINE (xm, ym)-(xmm, ymm), 0
LINE (xh, yh)-(xhh, yhh), 0
CIRCLE (x0, y0), bs * .75, 0, del1, del2
CIRCLE (x0, y0), bm * .3, 0, delm1, delm2
CIRCLE (x0, y0), bh * .8, 0, delh1, delh2

' hand positions
xs = x0 + bs * .95 * COS(alf)
ys = y0 + bs * .95 * SIN(alf)
xss = x0 + bs * COS(alf) * .66     'stay clear of min and hour hands
yss = y0 + bs * SIN(alf) * .66     '""
xh = x0 + bh * COS(gam) * .5
yh = y0 + bh * SIN(gam) * .5
xhh = x0 + 11 * COS(gam)           'stay clear of central circle
yhh = y0 + 11 * SIN(gam)           '""
xm = x0 + bm * COS(bet) * .66
ym = y0 + bm * SIN(bet) * .66
xmm = x0 + 11 * COS(bet)           'stay clear of central circle
ymm = y0 + 11 * SIN(bet)           '""

' draw hands
LINE (xss, yss)-(xs, ys), 14                  'sec hand
del1 = 2 * pi - alf - eps                     'hand arc
del2 = 2 * pi - alf + eps
IF del1 < 0 THEN del1 = 2 * pi + del1
IF del1 > 2 * pi THEN del1 = del1 - 2 * pi
IF del2 < 0 THEN del2 = del2 + 2 * pi
IF del2 > 2 * pi THEN del2 = del2 - 2 * pi
CIRCLE (x0, y0), bs * .75, 14, del1, del2

LINE (xhh, yhh)-(xh, yh), 13                   'hour hand
delh1 = 2 * pi - gam - eph                     'hand arc
delh2 = 2 * pi - gam + eph
IF delh1 < 0 THEN delh1 = 2 * pi + delh1
IF delh1 > 2 * pi THEN delh1 = delh1 - 2 * pi
IF delh2 < 0 THEN delh2 = delh2 + 2 * pi
IF delh2 > 2 * pi THEN delh2 = delh2 - 2 * pi
CIRCLE (x0, y0), bh * .2, 13, delh1, delh2

LINE (xm, ym)-(xmm, ymm), 11                   'min hand
delm1 = 2 * pi - bet - epm                     'hand arc
delm2 = 2 * pi - bet + epm
IF delm1 < 0 THEN delm1 = 2 * pi + delm1
IF delm1 > 2 * pi THEN delm1 = delm1 - 2 * pi
IF delm2 < 0 THEN delm2 = delm2 + 2 * pi
IF delm2 > 2 * pi THEN delm2 = delm2 - 2 * pi
CIRCLE (x0, y0), bm * .3, 11, delm1, delm2

loopen:
'sec chrono loop
IF INKEY$ <> "" THEN END
zeto% = zet%
IF zeto% = 360 THEN zeto% = 0
zet% = (TIMER - t) * 360
IF zet% > 330 THEN zet% = 360
'(kies 330 zodat geen spoor van voorgaande minuut)


FOR z% = zeto% TO zet%
PSET (x0 + bs * COS(-pi * .5 + z% * pi / 180), y0 + bs * SIN(-pi * .5 + z% * pi / 180)), col1 * (tel MOD 2)
NEXT z%
LOOP

END


